WeaponUp = LibStub("AceAddon-3.0"):NewAddon("WeaponUp", "AceEvent-3.0")
local self = WeaponUp

function WeaponUp:OnEnable()
	self:RegisterEvent("ADDON_LOADED")
	self:RegisterEvent("PLAYER_REGEN_DISABLED")
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	self:RegisterEvent("UNIT_INVENTORY_CHANGED")
	self:RegisterEvent("UI_ERROR_MESSAGE")
	self:RegisterEvent("PLAYER_ENTERING_WORLD")
	self.db = LibStub("AceDB-3.0"):New("WeaponUpDB")
end

SLASH_WeaponUp1 = "/wu";
local function handler(msg, editbox)
	if (msg=="off") then
		self.db.char.enable = false
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00WeaponUp:|r |cffff0000Off|r")
	end
	if (msg=="on") then
		self.db.char.enable = true
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00WeaponUp:|r |cff00ff00On|r")
	end
	if (msg=="help" or msg=="") then
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00WeaponUp:|r To enable or disable type /wu on or /wu off.")
	end
end
SlashCmdList["WeaponUp"] = handler;


function WeaponUp:ADDON_LOADED(event, addon)
	if addon == "WeaponUp" then
		WeaponUpDB = WeaponUpDB
		self:SetScript( "OnUpdate", handler)
	end
end

		
function WeaponUp:PLAYER_REGEN_DISABLED()
	if self.db.char.enable == false then
		return;
	end
	if (IsEquippedItemType("Fishing Poles") or IsEquippedItemType("Miscellaneous") or IsEquippedItem(46106) or IsEquippedItem(46069) or IsEquippedItem(46070)) and not UnitInVehicle("player")then
			EquipItemByName(self.db.char.mh, 16);
			if self.db.char.oh ~= nil then
			EquipItemByName(self.db.char.oh, 17);
			end
	end
end

function WeaponUp:COMBAT_LOG_EVENT_UNFILTERED(combatlogevent, ...)
	if self.db.char.enable == false then
		return;
	end
local sourceGUID = select(3, ...)
local type = select(2, ...)
local playerGUID = UnitGUID("player")			
	if (sourceGUID==playerGUID) and UnitAffectingCombat("player")then
		if (type == "SWING_DAMAGE" or type == "RANGE_DAMAGE" or type == "SPELL_DAMAGE" or type == "SWING_MISSED" or type == "RANGE_MISSED" or type == "SPELL_MISSED" or type == "SPELL_HEAL" ) then
			if (IsEquippedItemType("Fishing Poles") or IsEquippedItemType("Miscellaneous") or IsEquippedItem(46106) or IsEquippedItem(46069) or IsEquippedItem(46070)) and not UnitInVehicle("player")then
				EquipItemByName(self.db.char.mh, 16);
				if self.db.char.oh ~= nil then
				EquipItemByName(self.db.char.oh, 17);
				end
			end
		end
	end
end	

function WeaponUp:CheckSet()
local mainHandLink = GetInventoryItemLink("player",GetInventorySlotInfo("MainHandSlot"))
local secondaryHandLink = GetInventoryItemLink("player",GetInventorySlotInfo("SecondaryHandSlot"))
	if mainHandLink then
	local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(mainHandLink)
		if not UnitAffectingCombat("player") and not (IsEquippedItemType("Fishing Poles") or IsEquippedItem(46106) or IsEquippedItem(46069) or IsEquippedItem(46070)) and itemRarity > 1 and itemSubType ~= "Miscellaneous" then
			self.db.char.mh = itemName
		end
	end
	if secondaryHandLink then
	local itemName2, itemLink2, itemRarity2, itemLevel2, itemMinLevel2, itemType2, itemSubType2, itemStackCount2, itemEquipLoc2, itemTexture2, itemSellPrice2 = GetItemInfo(secondaryHandLink)
		if not UnitAffectingCombat("player") and not (IsEquippedItemType("Fishing Poles") or IsEquippedItem(46106) or IsEquippedItem(46069) or IsEquippedItem(46070)) and itemRarity2 > 1 and itemSubType2 ~= "Miscellaneous" then
			self.db.char.oh = itemName2
		end
		if not UnitAffectingCombat("player") and not (IsEquippedItemType("Fishing Poles") or IsEquippedItem(46106) or IsEquippedItem(46069) or IsEquippedItem(46070)) and itemRarity2 > 1 and itemSubType2 == "Miscellaneous" and itemType2 == "Armor" then  -- Held in offhand items
			self.db.char.oh = itemName2
		end
	end
	if mainHandLink and not secondaryHandLink then
		self.db.char.oh = nil
	end
end

function WeaponUp:UNIT_INVENTORY_CHANGED(event, unit)
	if (unit ~= "player")  or self.db.char.enable == false then
		return;
	end
	WeaponUp:CheckSet();
end

function WeaponUp:PLAYER_ENTERING_WORLD()
	if self.db.char.enable == false then
		return;
	end
	WeaponUp:CheckSet();
end

function WeaponUp:UI_ERROR_MESSAGE(event, message)
	if self.db.char.enable == false then
		return;
	end
	if message == "You must have a lance equipped." then
		EquipItemByName(46106)
		EquipItemByName(46069)
		EquipItemByName(46070)
	end
end